using Microsoft.EntityFrameworkCore;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace bitforum.Models.Page.Faq
{
    [Table("FaqCategory")]
    [Index(nameof(Code), Name = "IX_FaqCategory_Code", IsUnique = true)]
    [Index(nameof(Order), Name = "IX_FaqCategory_Order")]
    public class FaqCategory
    {
        public virtual List<FaqItem> FaqItem { get; set; } = new List<FaqItem>();

        [Key]
        public int ID { get; set; }

        [Required]
        [DisplayName("주소")]
        [DataType(DataType.Text)]
        [MaxLength(30)]
        [RegularExpression(@"^[a-zA-Z0-9]+$", ErrorMessage = "Code는 영문 및 숫자로만 구성되어야 합니다.")]
        public string Code { get; set; }

        [Required]
        [DisplayName("분류 명")]
        [DataType(DataType.Text)]
        [MaxLength(255)]
        public string Subject { get; set; }

        [Required]
        [DisplayName("순서")]
        public int Order { get; set; } = 0;

        [Required]
        [DisplayName("사용 여부")]
        public bool IsActive { get; set; } = false;

        [Display(Name = "수정일시")]
        [DataType(DataType.DateTime)]
        public DateTime? UpdatedAt { get; set; } = null;

        [Display(Name = "등록일시")]
        [DataType(DataType.DateTime)]
        public DateTime? CreatedAt { get; set; } = null;
    }
}
